import numpy as np
from math import sqrt, pi, log

def MakeSignal(n):
    t = np.arange(1.,n+1.)/n
    pos = np.array([ .1, .13, .15, .23, .25, .40, .44, .65,  .76, .78, .81])
    hgt = np.array([ 4,  5,   3,   4,  5,  4.2, 2.1, 4.3,  3.1, 5.1, 4.2])
    wth = np.array([.005, .005, .006, .01, .01, .03, .01, .01,  .005, .008, .005])
    sig1 = np.zeros((t.size))
    for j in range(pos.size) :
        sig1 = sig1 + hgt[j]/( 1 + np.abs((t - pos[j])/wth[j]))**4
    sig1=-15.*sig1

    N=round(n/12.)
    t = np.arange(1,N+1)/N
    sig2=-np.exp(4*t)
    N=round(n/7.)
    t = np.arange(1,N+1)/N
    sig5=np.exp(4*t)-np.exp(4)
    N=round(n/3.)
    t = np.arange(1,N+1)/N
    sigma=6./40.
    sig6=-70*np.exp(-((t-0.5)*(t-0.5))/(2*sigma**2))
    
    sig = np.zeros(n, dtype=float)
    N7=round(n/7.); N5=round(n/5.); N3=round(n/3.); N2=round(n/2.)
    N12=round(n/12.); N20=round(n/20.)
    sig[0:N7] = sig6[0:N7]
    sig[N7:N5]=0.5*sig6[N7:N5]
    sig[N5:N3]=sig6[N5:N3]
    sig[N3:N2]=sig1[N3:N2]
    sig[N2:N2+N12]=sig2
    sig[N2+N12:N2+2*N12]=sig2[::-1]
    sig[N2+2*N12+N20:N2+2*N12+3*N20]=-np.ones(N2+2*N12+3*N20-N2-2*N12-N20,dtype=float)*25
    k=N2+2*N12+3*N20
    sig[k:k+N7]=sig5
    diff=n-5*N5
    if (diff<0) :
        diff=0
    sig[5*N5:n]=sig[::-1][0:diff]
    #sig[5*N5:n]=sig[range(diff-1,0-1,-1)]                
    bias=sig.sum()/n
    sig=bias-sig


    t = np.arange(1.,n+1.)/n
    return t,sig
    